<template lang="pug">
div
  ZoomSenseConnection(
    :token="token",
    v-on:zoomsense:loading="loadingchanged",
    v-on:zoomsense:loaded="loaded",
    v-on:zoomsense:tokenerror="tokenerror",
    v-on:zoomsense:error="error"
  )
  div
    p Paste the &ldquo;Anonymous access token&rdquo; from #[a(href="https://zoomsense.io") ZoomSense], generated when sharing your meeting in ZoomSense.
    input(v-model="token", placeholder="ZoomSense Token")
    .danger {{ tokenerrormsg }}
    .text-center(v-show="loading") Loading...
  hr
  div(v-if="meetinginfo.topic")
    h2 Zoom Messages for {{ meetinginfo.topic }}
    h4.positive {{currentperson}} is speaking
    ul
      
      li(
        v-for="(content,index) of ordered",
        :key="JSON.stringify(content)"
      )
        div {{ content.msg }}
        em {{ content.msgSenderName }} - {{ ts(content.timestamp).toRelative() }}
</template>

<script>
import { DateTime } from "luxon";

export default {
  name: "ZoomSenseConfig",
  data() {
    return {
      zoomsense: {},
      meetinginfo: {},
      token: "",
      activity: {},
      loading: false,
      users: {},
      tokenerrormsg: "",
      currentperson: "nobody",
    };
  },
  created() {},
  computed: {
    ordered() {
      return Object.values(this.zoomsense).sort(
        (a, b) => a.timestamp - b.timestamp
      );
    },
  },
  watch: {
    activity: {
      deep: true,
      handler() {
        let key = Object.keys(this.activity)[0];
        let obj = this.activity[key];
        if (obj && obj.zoomid) {
          //get first person:
          let uid = obj.zoomid[0];
          if (this.users[uid]) {
            let username = this.users[uid].username;
            this.currentperson = username;
          }
        }
      },
    },
  },
  methods: {
    tokenerror(error) {
      this.tokenerrormsg = error;
    },
    error(error) {
      console.error(error);
    },
    loadingchanged(isloading) {
      this.loading = isloading;
    },
    loaded(data) {
      this.tokenerrormsg = "";
      this.meetinginfo = data.meeting;

      this.$rtdbBind(
        "zoomsense",
        data.data
          .child("chats")
          .child(this.meetinginfo.meetingid)
          .child("ZoomSensor_1")
      );
      this.$rtdbBind(
        "activity",
        data.data
          .child("activeSpeakers")
          .child(this.meetinginfo.meetingid)
          .child("ZoomSensor_1/current/activeHistory")
          .limitToLast(1)
      );
      this.$rtdbBind(
        "users",
        data.data
          .child("activeSpeakers")
          .child(this.meetinginfo.meetingid)
          .child("ZoomSensor_1/current/userList")
      );
    },
    ts(time) {
      if (time) return DateTime.fromMillis(time);
      else return DateTime.now();
    },
  },
};
</script>
